import 'bootstrap.css';
import '@grapecity/wijmo.styles/wijmo.css';
import './styles.css';
//
import { isArray } from '@grapecity/wijmo';
import { InputNumber, Menu } from '@grapecity/wijmo.input';
import { FlexPie, Palettes } from '@grapecity/wijmo.chart';
import { ChartAnimation, AnimationMode, Easing } from '@grapecity/wijmo.chart.animation';
import { getData, getRandomData } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let insertPieIdx = 1;
//
let flexPie = new FlexPie('#chart', {
bindingName: 'id',
binding: 'y0',
innerRadius: 0,
palette: getRandomPalette(),
itemsSource: getData()
});
//
//Pie Easing
let pieEasing = new Menu('#pieEasing', {
itemsSource: [
'Linear', 'Swing', 'EaseInQuad', 'EaseOutQuad', 'EaseInOutQuad', 'EaseInCubic', 'EaseOutCubic',
'EaseInOutCubic', 'EaseInQuart', 'EaseOutQuart', 'EaseInOutQuart', 'EaseInQuint', 'EaseOutQuint',
'EaseInOutQuint', 'EaseInSine', 'EaseOutSine', 'EaseInOutSine', 'EaseInExpo', 'EaseOutExpo',
'EaseInOutExpo', 'EaseInCirc', 'EaseOutCirc', 'EaseInOutCirc', 'EaseInBack', 'EaseOutBack',
'EaseInOutBack', 'EaseInBounce', 'EaseOutBounce', 'EaseInOutBounce', 'EaseInElastic',
'EaseOutElastic', 'EaseInOutElastic'
],
selectedValue: 'Swing',
itemClicked: (sender) => {
pieAnimation.easing = sender.selectedValue;
pieAnimation.animate();
updateMenuHeader(pieEasing, '<b>Easing</b>: ' + sender.text);
}
});
updateMenuHeader(pieEasing, '<b>Easing</b>: ' + pieEasing.text);
//
//Pie Duration
let pieDuration = new InputNumber('#pieDuration', {
value: 400,
min: 200,
max: 5000,
step: 200,
format: 'n0',
valueChanged: (sender) => {
pieAnimation.duration = sender.value;
pieAnimation.animate();
}
});
//
// Pie Inner Radius
let pieInnerRadius = new InputNumber('#pieInnerRadius', {
min: 0,
max: 1,
step: 0.1,
format: 'n1',
valueChanged: (sender) => {
if (sender.value < sender.min || sender.value > sender.max) {
return;
}
flexPie.innerRadius = sender.value;
}
});
//
// Pie Animation
let pieAnimation = new ChartAnimation(flexPie, {
animationMode: AnimationMode.All,
easing: Easing.Swing,
duration: 400
});
//
//Pie Animation Mode
let pieAnimationMode = new Menu('#pieAnimationMode', {
itemsSource: ['Point', 'Series', 'All'],
selectedValue: 'All',
itemClicked: (sender) => {
pieAnimation.animationMode = sender.selectedValue;
pieAnimation.animate();
updateMenuHeader(pieAnimationMode, '<b>Animation Mode</b>: ' + sender.text);
}
});
updateMenuHeader(pieAnimationMode, '<b>Animation Mode</b>: ' + pieAnimationMode.text);
//
//Pie Reset Data
document.querySelector('#pieResetData').addEventListener('click', () => {
flexPie.itemsSource = getData();
insertPieIdx = 1;
});
//
//Pie Add Slice
document.querySelector('#pieAddSlice').addEventListener('click', () => {
flexPie.itemsSource.push(getRandomData('added' + insertPieIdx));
insertPieIdx++;
});
//
//Pie Remove Slice
document.querySelector('#pieRemoveSlice').addEventListener('click', () => {
if (flexPie.itemsSource.length) {
flexPie.itemsSource.pop();
insertPieIdx = insertPieIdx <= 1 ? 1 : insertPieIdx--;
}
});
//
function updateMenuHeader(menu, value) {
menu.header = value;
}
}
//
function getRandomPalette() {
let palettes = Object.keys(Palettes).filter(prop => isArray(Palettes[prop]));
let rand = Math.floor(Math.random() * palettes.length);
//
return Palettes[palettes[rand]];
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>GrapeCity Wijmo FlexChart Pie Animation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div class="row">
<div class="col-sm-12 col-xs-12">
<div id="pieAnimationMode"></div>
<div id="pieEasing"></div>
<label for="pieDuration">Duration:</label>
<input id="pieDuration" />
</div>
</div>
<div class="row">
<div class="col-sm-12 col-xs-12">
<label for="pieInnerRadius">Inner Radius:</label>
<input id="pieInnerRadius" />
<button id="pieResetData" type="button" class="btn btn-default">reset data</button>
<button id="pieAddSlice" type="button" class="btn btn-default">add slice</button>
<button id="pieRemoveSlice" type="button" class="btn btn-default">remove slice</button>
</div>
</div>
<div id="chart"></div>
</div>
</body>
</html>
// generate some random data
import * as wijmo from '@grapecity/wijmo';
//
export function getData() {
let data = new wijmo.ObservableArray();
//
for (let i = 0; i < 5; i++) {
data.push(getRandomData('random' + getRandomValue(1000)));
}
//
return data;
}
//
export function getRandomData(id) {
return {
id: id,
y0: getRandomValue(200),
y1: getRandomValue(400),
y2: getRandomValue(600),
y3: getRandomValue(800),
y4: getRandomValue(1000)
};
}
//
function getRandomValue(max) {
return Math.round(Math.random() * max);
}
body {
margin-bottom: 24px;
}
.row {
margin: 10px -15px;
}
#pieAnimationMode {
width: 220px;
}
#pieEasing {
width: 220px;
}
#pieDuration, #pieInnerRadius {
width: 180px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js',
'@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js',
'@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles',
'@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures',
'@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js',
'@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js',
'@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js',
'@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js',
'@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js',
'@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js',
'@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js',
'@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js',
'@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js',
'@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js',
'@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js',
'@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js',
'@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js',
'@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js',
'@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js',
'@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js',
'@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js',
'@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js',
'@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js',
'@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js',
'@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js',
'@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js',
'@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js',
'@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js',
'@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js',
'@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js',
'@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js',
'@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js',
'@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js',
'@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js',
'@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js',
'@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js',
'@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js',
'@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js',
'@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js',
'@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js',
'@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js',
'@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js',
'@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js',
'@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js',
'@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js',
'@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import { isArray, ObservableArray } from '@mescius/wijmo';
import { FlexPie, Palettes } from '@mescius/wijmo.chart';
import { ChartAnimation } from '@mescius/wijmo.chart.animation';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import { WjChartAnimationModule } from '@mescius/wijmo.angular2.chart.animation';
import { DataService } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjInputModule, WjChartModule, WjChartAnimationModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
@ViewChild('pieAnimation', { static: true }) pieAnimation: ChartAnimation;
@ViewChild('pieChart', { static: true }) pieChart: FlexPie;
data: ObservableArray;
palette: string[];
//
private _insertPieIdx = 1;
//
constructor(@Inject(DataService) private dataService: DataService) {
this.data = dataService.getData();
this.palette = this._getRandomPalette();
}
//
private _animationMode = 'All';
get animationMode() {
return this._animationMode;
}
set animationMode(value: string) {
if (this._animationMode !== value) {
this._animationMode = value;
this.pieAnimation.animate();
}
}
//
private _easing = 'Swing';
get easing() {
return this._easing;
}
set easing(value: string) {
if (this._easing !== value) {
this._easing = value;
this.pieAnimation.animate();
}
}
//
private _duration = 400;
get duration() {
return this._duration;
}
set duration(value: number) {
if (this._duration !== value) {
this._duration = value;
this.pieAnimation.animate();
}
}
//
private _innerRadius = 0;
get innerRadius(): number {
return this._innerRadius;
}
set innerRadius(value: number) {
if (this._innerRadius !== value && value >= 0 && value <= 1) {
this.pieChart.innerRadius = this._innerRadius = value;
}
}
//
resetData() {
this.data = this.dataService.getData();
this._insertPieIdx = 1;
}
//
addSlice() {
this.data.push(this.dataService.getRandomData('added' + this._insertPieIdx));
this._insertPieIdx++;
}
//
removeSlice() {
if (this.data.length) {
this.data.pop();
this._insertPieIdx = this._insertPieIdx <= 1 ? 1 : this._insertPieIdx--;
}
}
//
private _getRandomPalette() {
let palettes = Object.keys(Palettes).filter((prop) => isArray(Palettes[prop]));
let rand = Math.floor(Math.random() * palettes.length);
//
return Palettes[palettes[rand]];
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Pie Animation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div class="row">
<div class="col-sm-12 col-xs-12">
<wj-menu [(value)]="animationMode" [header]="'Animation Mode'">
<wj-menu-item [value]="'Point'">Point</wj-menu-item>
<wj-menu-item [value]="'Series'">Series</wj-menu-item>
<wj-menu-item [value]="'All'">All</wj-menu-item>
</wj-menu>
<wj-menu [(value)]="easing" [header]="'Easing'">
<wj-menu-item [value]="'Linear'">Linear</wj-menu-item>
<wj-menu-item [value]="'Swing'">Swing</wj-menu-item>
<wj-menu-item [value]="'EaseOutQuad'">EaseOutQuad</wj-menu-item>
<wj-menu-item [value]="'EaseInOutQuad'">EaseInOutQuad</wj-menu-item>
<wj-menu-item [value]="'EaseInCubic'">EaseInCubic</wj-menu-item>
<wj-menu-item [value]="'EaseOutCubic'">EaseOutCubic</wj-menu-item>
<wj-menu-item [value]="'EaseInOutCubic'">EaseInOutCubic</wj-menu-item>
<wj-menu-item [value]="'EaseInQuart'">EaseInQuart</wj-menu-item>
<wj-menu-item [value]="'EaseOutQuart'">EaseOutQuart</wj-menu-item>
<wj-menu-item [value]="'EaseInOutQuart'">EaseInOutQuart</wj-menu-item>
<wj-menu-item [value]="'EaseInQuint'">EaseInQuint</wj-menu-item>
<wj-menu-item [value]="'EaseOutQuint'"> EaseOutQuint</wj-menu-item>
<wj-menu-item [value]="'EaseInOutQuint'">EaseInOutQuint</wj-menu-item>
<wj-menu-item [value]="'EaseInSine'">EaseInSine</wj-menu-item>
<wj-menu-item [value]="'EaseOutSine'">EaseOutSine</wj-menu-item>
<wj-menu-item [value]="'EaseInOutSine'">EaseInOutSine</wj-menu-item>
<wj-menu-item [value]="'EaseInExpo'">EaseInExpo</wj-menu-item>
<wj-menu-item [value]="'EaseOutExpo'">EaseOutExpo</wj-menu-item>
<wj-menu-item [value]="'EaseInOutExpo'">EaseInOutExpo</wj-menu-item>
<wj-menu-item [value]="'EaseInCirc'">EaseInCirc</wj-menu-item>
<wj-menu-item [value]="'EaseOutCirc'">EaseOutCirc</wj-menu-item>
<wj-menu-item [value]="'EaseInOutCirc'">EaseInOutCirc</wj-menu-item>
<wj-menu-item [value]="'EaseInBack'">EaseInBack</wj-menu-item>
<wj-menu-item [value]="'EaseOutBack'">EaseOutBack</wj-menu-item>
<wj-menu-item [value]="'EaseInOutBack'">EaseInOutBack</wj-menu-item>
<wj-menu-item [value]="'EaseInBounce'">EaseInBounce</wj-menu-item>
<wj-menu-item [value]="'EaseOutBounce'">EaseOutBounce</wj-menu-item>
<wj-menu-item [value]="'EaseInOutBounce'">EaseInOutBounce</wj-menu-item>
<wj-menu-item [value]="'EaseInElastic'">EaseInElastic</wj-menu-item>
<wj-menu-item [value]="'EaseOutElastic'">EaseOutElastic</wj-menu-item>
<wj-menu-item [value]="'EaseInOutElastic'">EaseInOutElastic</wj-menu-item>
</wj-menu>
<label for="pieDuration">Duration:</label>
<wj-input-number id="pieDuration" [(value)]="duration" [min]="200" [max]="5000" [step]="200"
[format]="'n0'">
</wj-input-number>
</div>
</div>
<div class="row">
<div class="col-sm-12 col-xs-12">
<label for="pieInnerRadius">Inner Radius:</label>
<wj-input-number id="pieInnerRadius" [(value)]="innerRadius" [min]="0" [max]="1" [step]="0.1"
[format]="'n1'">
</wj-input-number>
<button type="button" class="btn btn-default" (click)="resetData()">reset data</button>
<button type="button" class="btn btn-default" (click)="addSlice()">add slice</button>
<button type="button" class="btn btn-default" (click)="removeSlice()">remove slice</button>
</div>
</div>
<wj-flex-pie #pieChart [bindingName]="'id'" [binding]="'y0'" [innerRadius]="0" [palette]="palette"
[itemsSource]="data">
<wj-flex-chart-animation #pieAnimation [animationMode]="animationMode" [easing]="easing" [duration]="duration">
</wj-flex-chart-animation>
</wj-flex-pie>
</div>
import * as wijmo from '@mescius/wijmo';
import { Injectable } from '@angular/core';
//
@Injectable()
export class DataService {
getData() {
let data = new wijmo.ObservableArray();
//
for (let i = 0; i < 5; i++) {
data.push(this.getRandomData('random' + this._getRandomValue(1000)));
}
//
return data;
}
//
getRandomData(id: string) {
return {
id: id,
y0: this._getRandomValue(200),
y1: this._getRandomValue(400),
y2: this._getRandomValue(600),
y3: this._getRandomValue(800),
y4: this._getRandomValue(1000)
};
}
//
private _getRandomValue(max: number) {
return Math.round(Math.random() * max);
}
}
body {
margin-bottom: 24px;
}
.row {
margin: 10px -15px;
}
.wj-menu, .wj-inputnumber, .btn, label {
margin-right: 5px;
}
#pieAnimationMode {
width: 220px;
}
#pieEasing {
width: 250px;
}
#pieDuration, #pieInnerRadius {
width: 180px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjChart from '@mescius/wijmo.react.chart';
import * as wjChartAnimate from '@mescius/wijmo.react.chart.animation';
import * as wjInput from '@mescius/wijmo.react.input';
import './app.css';
import { getData, getRandomData, palette } from './data';
function App() {
const [data, setData] = useState(getData());
const [animationMode, setAnimationMode] = useState('All');
const [easing, setEasing] = useState('Swing');
const [duration, setDuration] = useState(400);
const [innerRadius, setInnerRadius] = useState(0);
const animationRef = useRef(null);
const insertPieIdxRef = useRef(1);
const animationInitialized = useEvent((ctrl) => {
animationRef.current = ctrl;
});
const animationModeChanged = useEvent((e) => {
if (e.selectedValue) {
setAnimationMode(e.selectedValue);
animationRef.current.animate();
}
});
const easingChanged = useEvent((e) => {
if (e.selectedValue) {
setEasing(e.selectedValue);
animationRef.current.animate();
}
});
const durationChanged = useEvent((e) => {
setDuration(e.value);
animationRef.current.animate();
});
const innerRadiusChanged = useEvent((e) => {
if (e.value < e.min || e.value > e.max) {
return;
}
setInnerRadius(e.value);
});
const resetData = useEvent(() => {
setData(getData());
insertPieIdxRef.current = 1;
});
const addSlice = useEvent(() => {
data.push(getRandomData('added' + insertPieIdxRef.current));
insertPieIdxRef.current++;
});
const removeSlice = useEvent(() => {
if (data.length) {
data.pop();
insertPieIdxRef.current = insertPieIdxRef.current <= 1 ? 1 : insertPieIdxRef.current--;
}
});
return (<div className="container-fluid">
<div className="row">
<div className="col-sm-12 col-xs-12">
<wjInput.Menu value={animationMode} header='Animation Mode' itemClicked={animationModeChanged}>
<wjInput.MenuItem value="Point">Point</wjInput.MenuItem>
<wjInput.MenuItem value="Series">Series</wjInput.MenuItem>
<wjInput.MenuItem value="All">All</wjInput.MenuItem>
</wjInput.Menu>
<wjInput.Menu value={easing} header='Easing' itemClicked={easingChanged}>
<wjInput.MenuItem value="Linear">Linear</wjInput.MenuItem>
<wjInput.MenuItem value="Swing">Swing</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutQuad">EaseOutQuad</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutQuad">EaseInOutQuad</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInCubic">EaseInCubic</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutCubic">EaseOutCubic</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutCubic">EaseInOutCubic</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInQuart">EaseInQuart</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutQuart">EaseOutQuart</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutQuart">EaseInOutQuart</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInQuint">EaseInQuint</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutQuint"> EaseOutQuint</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutQuint">EaseInOutQuint</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInSine">EaseInSine</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutSine">EaseOutSine</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutSine">EaseInOutSine</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInExpo">EaseInExpo</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutExpo">EaseOutExpo</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutExpo">EaseInOutExpo</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInCirc">EaseInCirc</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutCirc">EaseOutCirc</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutCirc">EaseInOutCirc</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInBack">EaseInBack</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutBack">EaseOutBack</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutBack">EaseInOutBack</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInBounce">EaseInBounce</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutBounce">EaseOutBounce</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutBounce">EaseInOutBounce</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInElastic">EaseInElastic</wjInput.MenuItem>
<wjInput.MenuItem value="EaseOutElastic">EaseOutElastic</wjInput.MenuItem>
<wjInput.MenuItem value="EaseInOutElastic">EaseInOutElastic</wjInput.MenuItem>
</wjInput.Menu>
<label htmlFor="pieDuration">Duration:</label>
<wjInput.InputNumber id="pieDuration" value={duration} min={200} max={5000} step={200} format="n0" valueChanged={durationChanged}>
</wjInput.InputNumber>
</div>
</div>
<div className="row">
<div className="col-sm-12 col-xs-12">
<label htmlFor="pieInnerRadius">Inner Radius:</label>
<wjInput.InputNumber id="pieInnerRadius" value={innerRadius} min={0} max={1} step={0.1} format="n1" valueChanged={innerRadiusChanged}>
</wjInput.InputNumber>
<button type="button" className="btn btn-default" onClick={resetData}>reset data</button>
<button type="button" className="btn btn-default" onClick={addSlice}>add slice</button>
<button type="button" className="btn btn-default" onClick={removeSlice}>remove slice</button>
</div>
</div>
<wjChart.FlexPie bindingName="id" binding="y0" innerRadius={innerRadius} palette={palette} itemsSource={data}>
<wjChartAnimate.FlexChartAnimation animationMode={animationMode} easing={easing} duration={duration} initialized={animationInitialized}/>
</wjChart.FlexPie>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexChart Pie Animation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.row {
margin: 10px -15px;
}
.wj-menu,
.wj-inputnumber,
.btn,
label {
margin-right: 5px;
}
#pieAnimationMode {
width: 220px;
}
#pieEasing {
width: 250px;
}
#pieDuration,
#pieInnerRadius {
width: 180px;
}
import { isArray } from '@mescius/wijmo';
import { Palettes } from '@mescius/wijmo.chart';
import * as wijmo from '@mescius/wijmo';
export function getData() {
let data = new wijmo.ObservableArray();
//
for (let i = 0; i < 5; i++) {
data.push(getRandomData('random' + getRandomValue(1000)));
}
//
return data;
}
export function getRandomData(id) {
return {
id: id,
y0: getRandomValue(200),
y1: getRandomValue(400),
y2: getRandomValue(600),
y3: getRandomValue(800),
y4: getRandomValue(1000)
};
}
function getRandomPalette() {
let palettes = Object.keys(Palettes).filter(prop => isArray(Palettes[prop]));
let rand = Math.floor(Math.random() * palettes.length);
//
return Palettes[palettes[rand]];
}
function getRandomValue(max) {
return Math.round(Math.random() * max);
}
export const data = getData();
export const palette = getRandomPalette();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div class="row">
<div class="col-sm-12 col-xs-12">
<wj-menu :value="animationMode" :header="'Animation Mode'" :itemClicked="animationModeChanged">
<wj-menu-item :value="'Point'">Point</wj-menu-item>
<wj-menu-item :value="'Series'">Series</wj-menu-item>
<wj-menu-item :value="'All'">All</wj-menu-item>
</wj-menu>
<wj-menu :value="easing" :header="'Easing'" :itemClicked="easingChanged">
<wj-menu-item :value="'Linear'">Linear</wj-menu-item>
<wj-menu-item :value="'Swing'">Swing</wj-menu-item>
<wj-menu-item :value="'EaseOutQuad'">EaseOutQuad</wj-menu-item>
<wj-menu-item :value="'EaseInOutQuad'">EaseInOutQuad</wj-menu-item>
<wj-menu-item :value="'EaseInCubic'">EaseInCubic</wj-menu-item>
<wj-menu-item :value="'EaseOutCubic'">EaseOutCubic</wj-menu-item>
<wj-menu-item :value="'EaseInOutCubic'">EaseInOutCubic</wj-menu-item>
<wj-menu-item :value="'EaseInQuart'">EaseInQuart</wj-menu-item>
<wj-menu-item :value="'EaseOutQuart'">EaseOutQuart</wj-menu-item>
<wj-menu-item :value="'EaseInOutQuart'">EaseInOutQuart</wj-menu-item>
<wj-menu-item :value="'EaseInQuint'">EaseInQuint</wj-menu-item>
<wj-menu-item :value="'EaseOutQuint'"> EaseOutQuint</wj-menu-item>
<wj-menu-item :value="'EaseInOutQuint'">EaseInOutQuint</wj-menu-item>
<wj-menu-item :value="'EaseInSine'">EaseInSine</wj-menu-item>
<wj-menu-item :value="'EaseOutSine'">EaseOutSine</wj-menu-item>
<wj-menu-item :value="'EaseInOutSine'">EaseInOutSine</wj-menu-item>
<wj-menu-item :value="'EaseInExpo'">EaseInExpo</wj-menu-item>
<wj-menu-item :value="'EaseOutExpo'">EaseOutExpo</wj-menu-item>
<wj-menu-item :value="'EaseInOutExpo'">EaseInOutExpo</wj-menu-item>
<wj-menu-item :value="'EaseInCirc'">EaseInCirc</wj-menu-item>
<wj-menu-item :value="'EaseOutCirc'">EaseOutCirc</wj-menu-item>
<wj-menu-item :value="'EaseInOutCirc'">EaseInOutCirc</wj-menu-item>
<wj-menu-item :value="'EaseInBack'">EaseInBack</wj-menu-item>
<wj-menu-item :value="'EaseOutBack'">EaseOutBack</wj-menu-item>
<wj-menu-item :value="'EaseInOutBack'">EaseInOutBack</wj-menu-item>
<wj-menu-item :value="'EaseInBounce'">EaseInBounce</wj-menu-item>
<wj-menu-item :value="'EaseOutBounce'">EaseOutBounce</wj-menu-item>
<wj-menu-item :value="'EaseInOutBounce'">EaseInOutBounce</wj-menu-item>
<wj-menu-item :value="'EaseInElastic'">EaseInElastic</wj-menu-item>
<wj-menu-item :value="'EaseOutElastic'">EaseOutElastic</wj-menu-item>
<wj-menu-item :value="'EaseInOutElastic'">EaseInOutElastic</wj-menu-item>
</wj-menu>
<label for="pieDuration">Duration:</label>
<wj-input-number id="pieDuration" :value="duration" :min=200 :max=5000 :step=200 format="n0"
:valueChanged="durationChanged">
</wj-input-number>
</div>
</div>
<div class="row">
<div class="col-sm-12 col-xs-12">
<label for="pieInnerRadius">Inner Radius:</label>
<wj-input-number id="pieInnerRadius" :value="innerRadius" :min=0 :max=1 :step=0.1 format="n1"
:valueChanged="innerRadiusChanged">
</wj-input-number>
<button type="button" class="btn btn-default" @click="resetData">reset data</button>
<button type="button" class="btn btn-default" @click="addSlice">add slice</button>
<button type="button" class="btn btn-default" @click="removeSlice">remove slice</button>
</div>
</div>
<wj-flex-pie bindingName="id" binding="y0" :innerRadius="innerRadius" :palette="palette" :itemsSource="data">
<wj-flex-chart-animation :animationMode="animationMode" :easing="easing" :duration="duration"
:initialized="animationInitialized">
</wj-flex-chart-animation>
</wj-flex-pie>
</div>
</template>
<script setup>
import { isArray } from "@mescius/wijmo";
import { Palettes } from "@mescius/wijmo.chart";
import { getData, getRandomData } from "./data";
import { ref } from "vue";
const data = ref(getData());
const palette = ref(null);
const animationMode = ref("All");
const easing = ref("Swing");
const duration = ref(400);
const innerRadius = ref(0);
const animation = ref(null);
const _insertPieIdx = ref(null);
function animationInitialized(ctrl) {
animation.value = ctrl;
}
function animationModeChanged(e) {
if (e.selectedValue) {
animationMode.value = e.selectedValue;
animation.value.animate();
}
}
function easingChanged(e) {
if (e.selectedValue) {
easing.value = e.selectedValue;
animation.value.animate();
}
}
function durationChanged(e) {
duration.value = e.value;
if (animation.value) {
animation.value.animate();
}
}
function innerRadiusChanged(e) {
if (e.value < e.min || e.value > e.max) {
return;
}
innerRadius.value = e.value;
}
function resetData() {
data.value = getData();
_insertPieIdx.value = 1;
}
function addSlice() {
data.value.push(getRandomData("added" + _insertPieIdx.value));
_insertPieIdx.value++;
}
function removeSlice() {
if (data.value.length) {
data.value.pop();
_insertPieIdx.value = _insertPieIdx.value <= 1 ? 1 : _insertPieIdx.value--;
}
}
function _getRandomPalette() {
let palettes = Object.keys(Palettes).filter((prop) => isArray(Palettes[prop]));
let rand = Math.floor(Math.random() * palettes.length);
//
return Palettes[palettes[rand]];
}
</script>
<style>
body {
margin-bottom: 24px;
}
.row {
margin: 10px -15px;
}
#pieAnimationMode {
width: 220px;
}
#pieEasing {
width: 220px;
}
#pieDuration,
#pieInnerRadius {
width: 180px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Pie Animation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
import * as wijmo from '@mescius/wijmo';
//
// generate some random data
export function getData() {
let data = new wijmo.ObservableArray();
//
for (let i = 0; i < 5; i++) {
data.push(getRandomData('random' + getRandomValue(1000)));
}
//
return data;
}
//
export function getRandomData(id) {
return {
id: id,
y0: getRandomValue(200),
y1: getRandomValue(400),
y2: getRandomValue(600),
y3: getRandomValue(800),
y4: getRandomValue(1000)
};
}
//
function getRandomValue(max) {
return Math.round(Math.random() * max);
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);